(define-module (ui logs ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :export (init))

;;; Functions
(define (do-apply data)
  (form-update-value-list '("start" "size" "text" "range") data))

(define (do-update . args)
  (catch/message
    (lambda()
      (do-apply (apply woo-read-first "/logs" 
		       'start (form-value "start")
		       'size (form-value "size")
		       'name (form-value "name")
		       args)))))

(define (do-select)
  (do-apply (woo-read-first "/logs"
			    'name (form-value "name")
			    'last #t)))

(define (do-size)
  (do-update 'new_size (form-value "new_size")))

(define (do-back)
  (do-update 'back #t))

(define (do-next)
  (do-update 'next #t))

(define (do-first)
  (do-update 'first #t))

(define (do-last)
  (do-update 'last #t))

(define (init)
  (catch/message
    (lambda()
      (let ((data (woo-read-first "/logs" 'last #t)))
	(form-update-enum "name" (woo-list "/logs/avail_log" 'language (form-value "language")))
	(form-update-enum "new_size" (woo-list "/logs/avail_size" 'language (form-value "language")))
	(form-update-value-list '("name" "new_size") data)
	(do-apply data)
	(form-bind "name" "change" do-select)
	(form-bind "new_size" "change" do-size)
	(form-bind "back_button" "click" do-back)
	(form-bind "next_button" "click" do-next)
	(form-bind "first_button" "click" do-first)
	(form-bind "last_button" "click" do-last)))))

