(document:surround "/std/frame")

;;; Functions
(define (do-apply data)
  (form-update-value-list '("start" "size" "text" "range") data))

(define (do-update . args)
  (catch/message
    (lambda()
      (do-apply (apply woo-read-first "/logs" 
		       'start (form-value "start")
		       'size (form-value "size")
		       'name (form-value "name")
		       args)))))

(define (do-select)
  (do-apply (woo-read-first "/logs"
			    'name (form-value "name")
			    'last #t)))

(define (do-size)
  (do-update 'new_size (form-value "new_size")))

(define (do-back)
  (do-update 'back #t))

(define (do-next)
  (do-update 'next #t))

(define (do-first)
  (do-update 'first #t))

(define (do-last)
  (do-update 'last #t))

(define (do-init)
  (catch/message
    (lambda()
      (let ((data (woo-read-first "/logs" 'last #t)))
	(form-update-enum "name" (woo-list "/logs/avail_log"))
	(form-update-enum "new_size" (woo-list "/logs/avail_size"))
	(form-update-value-list '("name" "new_size") data)
	(do-apply data)
	(form-bind "name" "change" do-select)
	(form-bind "new_size" "change" do-size)
	(form-bind "back_button" "click" do-back)
	(form-bind "next_button" "click" do-next)
	(form-bind "first_button" "click" do-first)
	(form-bind "last_button" "click" do-last)))))

;;; UI
(edit name "start" visibility #f)
(edit name "size"  visibility #f)
margin "10"
(hbox align "left"
      (label text (_ "Logs:"))
      (label text " ")
      (combobox name "name"))
(textbox name "text")
(hbox align "left"
      (label name "range")
      (button text (_ "Previous") name "back_button")
      (button text (_ "Next") name "next_button")
      (label)
      (button text (_ "First page") name "first_button")
      (button text (_ "Last page") name "last_button")
      (label text "|")
      (label text (_ "Show:"))
      (label " ")
      (combobox name "new_size"))

;;; Logic
(document:root (when loaded (do-init)))
